/*
	File:		CompDefs.h

	Contains:	Defines for compiling OpenDoc parts.

	Written by:	Steve Smith
	
	Copyright:	 1994,95 by Apple Computer, Inc., all rights reserved.
*/

#ifndef _COMPILERDEFS_
#define _COMPILERDEFS_

// Just before you are ready to ship, uncomment the line below.
// Doing so will remove all the ACF_DevServ2_ListEx1PartMethodDebug()
// lines from the generated code.
// Note: The _RETAIL switch can be found in somcdev.h
//#define _RETAIL

// We should no longer be using the "old" routine names/structs.
#ifndef OLDROUTINENAMES
#define OLDROUTINENAMES 0
#endif
#ifndef OLDROUTINELOCATIONS
#define OLDROUTINELOCATIONS 0
#endif
	
// Some public headers #ifdef out structs not useful to other platforms.
#ifndef _PLATFORM_MACINTOSH_
#define _PLATFORM_MACINTOSH_ 1
#endif

// If you use the StdTypIO utility, you must define the platform's
// endian-ness.
#ifndef _PLATFORM_BIG_ENDIAN_
#define _PLATFORM_BIG_ENDIAN_ 1
#endif

// There is an apparent bug in the ConditionalMacros.h v2.1 header. This
// prevents the Symantec 8.0 C++ compiler from exporting symbols. To work
// around the problem, we define PRAGMA_IMPORT_SUPPORTED.
#if defined(__SC__)
#define PRAGMA_IMPORT_SUPPORTED 1
#endif

// ODDebug must be defined because we are using Except.cpp & ODDebug.cpp.
#ifdef _RETAIL
	// turn off debugging
	#ifndef ODDebug
	#define ODDebug 0
	#endif
#else
	// turn on debugging and traceback symbols (PPC only)
	#ifndef ODDebug
	#define ODDebug 1
	#endif
	#pragma traceback on
#endif

#endif