/*
	File:		ListPartGlobals.h

	Contains:	ListPart globals

	Written by:	Steve Smith

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
*/


#ifndef _LISTPARTGLOBALS_
#define _LISTPARTGLOBALS_

// -- OpenDoc --

#ifndef _ODTYPES_
#include <ODTypes.h>
#endif

#ifndef SOM_Module_OpenDoc_StdDefs_defined
#include <StdDefs.h>
#endif

#ifndef _ITEXT_
#include <IText.h>
#endif

// -- MacToolbox --

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __QDOFFSCREEN__
#include <QDOffScreen.h>
#endif

#ifndef SOM_ACF_DevServ_som_ListPart_xh
#include "som_ListPart.xh"
#endif

class ODMenuBar;
class ODFocusSet;


//==============================================================================
// Globals
//==============================================================================

struct ListPartGlobals; // forward

extern	ODUShort			gGlobalsUsageCount;
extern	ListPartGlobals*	gGlobals;


struct ListPartGlobals {
	public:
	ListPartGlobals();
	~ListPartGlobals() {}
	
	ODMenuBar*		fMenuBar;
	ODFocusSet*		fUIFocusSet;	
				
	ODTypeToken		fSelectionFocus;
	ODTypeToken		fMenuFocus;
	ODTypeToken		fModalFocus;
	ODTypeToken		fFrameView;
	ODTypeToken		fLargeIconView;
	ODTypeToken		fSmallIconView;
	ODTypeToken		fThumbnailView;
	ODTypeToken		fMainPresentation;
			
	ODScriptCode	fEditorsScript;
	ODLangCode		fEditorsLanguage;

// ES 11/13/95
	ODTypeToken		fKeyFocus;
	ODTypeToken		fScrollFocus;
};


inline ListPartGlobals::ListPartGlobals()
{
	fMenuBar		= kODNULL;
	fUIFocusSet		= kODNULL;	
				
	fSelectionFocus			= kODNullTypeToken;
	fMenuFocus				= kODNullTypeToken;
	fModalFocus				= kODNullTypeToken;
	fFrameView				= kODNullTypeToken;
	fLargeIconView			= kODNullTypeToken;
	fSmallIconView			= kODNullTypeToken;
	fThumbnailView			= kODNullTypeToken;
	fMainPresentation		= kODNullTypeToken;
			
	fEditorsScript		= 0;
	fEditorsLanguage	= 0;

// ES 11/13/95
	fScrollFocus			= kODNullTypeToken;
	fKeyFocus				= kODNullTypeToken;
}

#endif