/*
	File:		AEThreads.h
 				 
	Contains:	Interfaces for installing threaded AppleEvent handlers

	Written by: Steve Sisak

 	Copyright:	 1993-94 Steve Sisak
				License is granted to use, modify, make derivative works, and 
				duplicate this code at will, so long as this notice remains intact.

*/

#ifndef __AETHREADS__
#define __AETHREADS__
#pragma once


#ifndef __THREADS__
#include <Threads.h>
#endif

#ifndef __APPLEEVENTS__
#include <AppleEvents.h>
#endif


pascal OSErr AEHandleInThread(
					const AppleEvent*	event,
					AppleEvent*			reply,
					AEEventHandlerUPP	handler,
					long				handlerRefcon,
					ThreadOptions		options,
					Size				stacksize);	

pascal OSErr AEInstallThreadedEventHandler(
					AEEventClass		theAEEventClass,
					AEEventID			theAEEventID,
					AEEventHandlerUPP	proc,
					long				handlerRefcon,
					ThreadOptions		options,
					Size				stacksize);	

#endif // __AETHREADS__