/*
	File:		BigBrains.h

	Contains:	Definitions for Application-specific code for BigBrains.
				
	Written by: Kent Miller

	Copyright:	 1996 by Kent Miller, all rights reserved.

	Change History (most recent first):
 */

#ifndef	_SUPERFLY_
#define	_SUPERFLY_

#include "LinkedList.h"
#include "SuperFlyToolWindow.h"

enum {
	kAboutBox = 128,
	cMirroring = 1000,
	cAboutSprocket = 1001,
	kErrorList	= 128,
	kNoDisplayManager = 1,
	kNoColorQD = 2
	};


//Function Prototypes
void	SuperFlyTearDownMyWindows(void);
OSErr	SuperFlySetUpWindows(void);
void	SuperFlyHandleGDevicesMoved(void);
void	AboutBox(void);

//Global variables unique to our application
extern 		TLinkedList 		*gMyWindowList;
extern		TSuperFlyToolWindow *gMyToolWindow;
extern		Boolean				gMirroringWasOn;  //Was mirroring on when I started?
extern		Boolean				gHasTranslucentDrag;

#endif
